﻿using System;
using System.Collections.Generic;
using System.Text;
using Bonea.PropertyRegister.Common;
using Bonea.PropertyRegister.WebServiceCommon;
using System.Xml.Serialization;

namespace Bonea.PropertyRegister.MunicipalityProperty.Entities
{
    public class PropertyCertificate
    {
        public PropertyCertificate()
        {
            mID = AppConst.UnknownID;
            mPropertyList = new List<Property>();
            mTaxAssesment = 0.0M;
            mMarketAssesment = 0.0M;
            mDateCreated = DateTime.Now;
            mRegistrationDate = DateTime.Now;
        }

        private int mID;
        private PropertyCertificateStatus mStatus;
        private PropertyCertificateType mDocumentType;
        private AppUser mCreatedByUser;
        private AppUser mApprovedByUser;
        private AppUser mSignedByUser;
        private AppUser mLastUpdatedByUser;
        private int mNumber;
        private DateTime mDateCreated;
        private string mRegisterNumber;
        private string mCardIndexNumber;
        private string mFileNumber;
        private string mLawReason;
        private string mDescription;
        private string mLocation;
        private string mBorders;
        private decimal mTaxAssesment;
        private decimal mMarketAssesment;
        private string mExOwners;
        private string mOwners;
        private string mExCertificates;
        private string mOrders;
        private string mNotes;
        private string mRejectRemarks;
        private string mRegistrationNumber;
        private DateTime mRegistrationDate;
        private DateTime mLastSavedTime;
        private PropertyCertificateIssuer mIssuer;
        private int mWorkspaceID;
        IList<Property> mPropertyList;

        public int ID
        {
            get { return mID; }
            set { mID = value; }
        }

        public PropertyCertificateStatus Status
        {
            get { return mStatus; }
            set { mStatus = value; }
        }

        public PropertyCertificateType DocumentType
        {
            get { return mDocumentType; }
            set { mDocumentType = value; }
        }

        public DateTime DateCreated
        {
            get { return mDateCreated; }
            set { mDateCreated = value; }
        }

        public string RegisterNumber
        {
            get { return mRegisterNumber; }
            set { mRegisterNumber = value; }
        }

        public string CardIndexNumber
        {
            get { return mCardIndexNumber; }
            set { mCardIndexNumber = value; }
        }

        public string FileNumber
        {
            get { return mFileNumber; }
            set { mFileNumber = value; }
        }

        public string LawReason
        {
            get { return mLawReason; }
            set { mLawReason = value; }
        }

        public string Description
        {
            get { return mDescription; }
            set { mDescription = value; }
        }

        public string Location
        {
            get { return mLocation; }
            set { mLocation = value; }
        }

        public string Borders
        {
            get { return mBorders; }
            set { mBorders = value; }
        }

        public decimal TaxAssesment
        {
            get { return mTaxAssesment; }
            set { mTaxAssesment = value; }
        }

        public decimal MarketAssesment
        {
            get { return mMarketAssesment; }
            set { mMarketAssesment = value; }
        }

        public string ExOwners
        {
            get { return mExOwners; }
            set { mExOwners = value; }
        }

        public string Owners
        {
            get { return mOwners; }
            set { mOwners = value; }
        }

        public string ExCertificates
        {
            get { return mExCertificates; }
            set { mExCertificates = value; }
        }

        public string Orders
        {
            get { return mOrders; }
            set { mOrders = value; }
        }

        public string Notes
        {
            get { return mNotes; }
            set { mNotes = value; }
        }

        public string RejectRemarks
        {
            get { return mRejectRemarks; }
            set { mRejectRemarks = value; }
        }

        public string RegistrationNumber
        {
            get { return mRegistrationNumber; }
            set { mRegistrationNumber = value; }
        }

        public DateTime RegistrationDate
        {
            get { return mRegistrationDate; }
            set { mRegistrationDate = value; }
        }

        public AppUser CreatedByUser
        {
            get { return mCreatedByUser; }
            set { mCreatedByUser = value; }
        }

        public AppUser ApprovedByUser
        {
            get { return mApprovedByUser; }
            set { mApprovedByUser = value; }
        }

        public AppUser SignedByUser
        {
            get { return mSignedByUser; }
            set { mSignedByUser = value; }
        }

        public AppUser LastUpdatedByUser
        {
            get { return mLastUpdatedByUser; }
            set { mLastUpdatedByUser = value; }
        }

        public int Number
        {
            get { return mNumber; }
            set { mNumber = value; }
        }

        public DateTime LastSavedTime
        {
            get { return mLastSavedTime; }
            set { mLastSavedTime = value; }
        }

        public PropertyCertificateIssuer Issuer
        {
            get { return mIssuer; }
            set { mIssuer = value; }
        }

        [XmlIgnore]
        public IList<Property> PropertyList
        {
            get { return mPropertyList; }
            set { mPropertyList = value; }
        }

        public Property[] SerializablePropertyList
        {
            get
            {
                return AppUtils.ListToFixedArray<Property>(mPropertyList);
            }
            set 
            {
                mPropertyList = new List<Property>(value);
            }
        }

        public int WorkspaceID
        {
            get { return mWorkspaceID; }
            set { mWorkspaceID = value; }
        }

        public bool IsNew
        {
            get 
            {
                if (ID == AppConst.UnknownID)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }
    }
}
