﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

namespace Bonea.PropertyRegister.DataAccess
{
    public class SessionManagerFactory
    {
        private SessionManagerFactory()
        {
        }

        private const string ORM_MANAGER_TYPE_SECTION = "SessionManager";

        public static SessionManager GetInstance()
        {
            string sessionManagerType =
                ConfigurationManager.AppSettings[ORM_MANAGER_TYPE_SECTION];
            if (sessionManagerType == typeof(PerRequestSessionManager).Name)
            {
                return new PerRequestSessionManager();
            }
            else
            {
                throw new Exception("Unknown session manager type");
            }
        }
    }
}
