﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Web.Services3.Security.Tokens;
using System.Security.Permissions;
using System.Xml;
using System.Security.Principal;
using System.Threading;

namespace Bonea.PropertyRegister.WebServiceCommon
{
    [SecurityPermissionAttribute(SecurityAction.Demand,
        Flags = SecurityPermissionFlag.UnmanagedCode)]
    public class SqlServerTokenManager : UsernameTokenManager
    {
        public SqlServerTokenManager()
        {
        }

        public SqlServerTokenManager(XmlNodeList nodes)
            : base(nodes)
        {
        }

        protected override string AuthenticateToken(UsernameToken token)
        {
            if (UserManager.LogIn(token.Username, token.Password) == false)
            {
                throw new ApplicationException("Not a valid user");
            }

            GenericIdentity identity = new GenericIdentity(token.Username);
            GenericPrincipal principal = new GenericPrincipal(identity,
                UserManager.GetUserCredentials(token.Username));

            Thread.CurrentPrincipal = principal;

            return token.Password;
        }
    }
}
